Include "HjGlobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
include "MSAAConst.jsh"
include "UIA.jsh"
include "CDEx.jsh"

; ---------------------------------------------------------------------------------------------
; Funktionen
; ---------------------------------------------------------------------------------------------
; AutoStartEvent (): Prfen auf Version 
; ActivateByAutomationID (string sAutomationID)
; GetNameFromAutomationID (string sAutomationID)
; IsSettingsDialog (): True, wenn wir uns im Einstellugnsdialog befinden 
; IsPage (string sPagename); True, wenn der Seitenname im Einstellungsdialog aktiviert ist 
; IsMainWindow (): True, wenn wir uns im Hauptfenster befinden 
; IsCDList (): True, wenn wir im Hauptfenster in der Liste mit den CD-Tracks befinden 
; FocusChangedEventEx (): Zum richtigen Sprechen der Steuerelemente 
; ChangeFolder (int iButton): Aufrufen der Schaltflche zum Anzeigen der Dateiauswahl 
; GetTVText (): Aktuell ausgewhlte Seite in den Einstellungen 
; ReadExtractDialog (optional int iValue): Liest Text im Fortschrittsanzeigen-Dialog
; IsExtractDialog (): True, wenn der Fortschrittsanzeigen-Dialog fr Kodieren aktiv ist 
; IsConvertDialog (): True, wenn der Fortschrittsanzeigen-Dialog fr Knvertierung aktiv ist 
; HandleCustomRealWindows (handle hWindow): Event-Funktion zum Stopfen der Sprache, wenn der berschrieben-Dialog isch vor den Fortschrittsanzeigen-Dialog legt
; ---------------------------------------------------------------------------------------------
; Skripts
; ---------------------------------------------------------------------------------------------
; F2 (F2): Fhrt abhngig vom Steuerelement diverse Funktionen beim Drcken von F2 aus
; F6 (F6): Wechselt per UIA in den Einstellungen zur Baumansicht (Kategorien-Seiten)
; FocusTreeView (-): Wie F6-Skript, nur mit Windows-API
; ScriptFileName (JAWS+Q): Spricht Skriptdateiname 
; SayPage (Alt+F1): Spricht aktuell gewhlte Kategorie-Seite im Einstellungsdialog
; SayTrackFromTrack (Strg+N): Spricht im Extrahierendialog die gerade umgewandelte Nummer (x von y)
; SayFilename (Strg+F): Spricht im Extrahierendialog den gerade umgewandelten Dateinamen 
; SayPeak (Strg+G): Spricht im Extrahierendialog den Gipfelwert der aktuellen Datei 
; SayTimeTrack (Strg+T): Spricht im Extrahierendialog die umgewandelte Zeit, verbleibende Zeit und geschtzte Zeit des aktuellen Tracks
; SayTimeCD (Strg+G): Spricht im Extrahierendialog die umgewandelte Zeit, verbleibende Zeit und geschtzte Zeit der kompletten CD
; SayJitter (Strg+J): Spricht die Jitter-Fehler im Extrahierendialog
; SayProgress (Strg+I): Spricht alle Text-Anzeigen im Extrahierendialog
; Eject (Strg+Entf.): ffnet CD-Schubfach
; ChangeDrive (Strg+L): Aktiviert die ComboBox zur Auswahl des Laufwerks
; ---------------------------------------------------------------------------------------------

Void Function AutoStartEvent ()
If !(GetVersionInfoString (GetAppFilePath (), "FileVersion")) == cCDExVersion then
MessageBox (msgNoRightVersion)
EndIf 
EndFunction

; ---------------------------------------------------------------------------------------------

string Function ActivateByAutomationID (string sAutomationID)
var
 object oUIA,
 object oElement,
 object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
if !oUIA then Return False EndIf 
oElement = oUIA.GetElementFromHandle(GetAppMainWindow(GetFocus()))
if !oElement then Return False EndIf 
oCondition = oUIA.CreateStringPropertyCondition(UIA_AutomationIDPropertyId, sAutomationID)
if !oCondition then Return False EndIf 
oElement = oElement.FindFirst (treeScope_descendants, oCondition)

If oElement then
oElement.SetFocus()
EndIf ; If oElement then
EndFunction 

; ---------------------------------------------------------------------------------------------

string Function GetNameFromAutomationID (string sAutomationID)
var
 object oUIA,
 object oElement,
 object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
if !oUIA then Return False EndIf 
oElement = oUIA.GetElementFromHandle(GetAppMainWindow(GetFocus()))
if !oElement then Return False EndIf 
oCondition = oUIA.CreateStringPropertyCondition(UIA_AutomationIDPropertyId, sAutomationID)
if !oCondition then Return False EndIf 
oElement = oElement.FindFirst (treeScope_descendants, oCondition)

If oElement then
Return oElement.Name
EndIf ; If oElement then
EndFunction 

; ---------------------------------------------------------------------------------------------

int Function IsSettingsDialog ()
var
string sTitle
If DialogActive () then
sTitle = GetWindowName (GetRealWindow(GetFocus()))
	If sTitle == cCDExSettingsTitle then
	Return True
	else
	Return False
	EndIf ; If sTitle == CDExSettingsTitle then
EndIf ; If DialogActive () then
EndFunction

; ---------------------------------------------------------------------------------------------

int Function IsPage (string sPagename)
If IsSettingsDialog () then
var 
handle hTreeView = FindWindow (GetRealWindow(GetFocus()), cSysTreeView, "")
	If hTreeView then 
		If StringLower (tvGetFocusItemText (hTreeView)) == StringLower (sPagename) then
		Return True
		else
		Return False
		EndIf ; If StringLower (tvGetFocusItemText (hTreeView)) == StringLower (sPagename) then
	EndIf ; If hTreeView then
EndIf ; If IsSettingDialog () then
EndFunction 

; ---------------------------------------------------------------------------------------------

int Function IsMainWindow ()
var
handle hMain = GetAppMainWindow (GetFocus()),
handle hReal = GetRealWindow (GetFocus())
Return hMain == hReal
EndFunction

; ---------------------------------------------------------------------------------------------

int Function IsCDList ()
var
int iControlID = GetControlID (GetFocus()), 
string sTemp = GetWindowName (GetFocus())
Return (iControlID == idTrackList) && (sTemp == idTrackListName)
EndFunction 

; ---------------------------------------------------------------------------------------------

void function FocusChangedEventEx (handle hwndFocus, int nObject, int nChild, handle hwndPrevFocus, int nPrevObject, int nPrevChild, int nChangeDepth)
var
int iControlID = GetControlID (GetFocus()), 
string sTitle, 
int iPos, 
int iMax

If IsCDList () then
If !giInTackList then
SayString (msgTrackList)
EndIf 

iMax = lvGetItemCount (GetFocus())
iPos = lvGetFocusItem (GetFocus())
sTitle = lvGetItemText (GetFocus(), lvGetFocusItem (GetFocus()), 1)
SayString (FormatString ("%1, %2 von %3", sTitle, iPos, iMax))

giInTackList = True
Return
else
giInTackList = False
EndIf 

; Hauptfenster

If IsMainWindow () then

   If iControlID == idArtist then 
   SayString (msgArtist)
   SayLine ()
   Return
   EndIf 

   If iControlID == idTitle then 
   SayString (msgTitle)
   SayLine ()
   Return
   EndIf 
   
   If iControlID == idGenre then 
   SayString (msgGenre)
   SayLine ()
   Return
   EndIf 

   If iControlID == idYear then 
   SayString (msgYear)
   SayLine ()
   Return
   EndIf 
 
EndIf ; If IsMainWindow () then

; Einstellungen
; Seite Allgemein 

If IsPage (cCommon) then

   If iControlID == idTempFiles then 
   SayString (msgTempFiles)
   SayString (msgF2ToChange)
   SayLine ()
   Return
   EndIf 

   If iControlID == idNormalice1 then 
   SayString (msgNormalice1)
   SayString (GetSelectedText (False, False))
   Return
   EndIf 

   If iControlID == idNormalice2 then 
   SayString (msgNormalice2)
   SayString (GetSelectedText (False, False))
   Return
   EndIf 

   If iControlID == idNormalice3 then 
   SayString (msgNormalice3)
   SayString (GetSelectedText (False, False))
   Return
   EndIf 

   If iControlID == idNormalice4 then 
   SayString (msgNormalice4)
   SayString (GetSelectedText (False, False))
   Return
   EndIf 
   
EndIf ; If IsPage (cCommon) then

; Seite Dateinamen

If IsPage (cFilenames) then
   If iControlID == idFormat then 
   SayString (msgFormat)
   SayString (msgInfo)
   Return
   EndIf 

   If iControlID == idFormatHelp then 
   SayString (msgFormatHelp)
   Return
   EndIf 

   If iControlID == idWaveToMp3 then  
   SayString (msgWaveToMp3)
   SayString (msgF2ToChange)
   EndIf 

   If iControlID == idRecord then   
   SayString (msgRecord)
   SayString (msgF2ToChange)
   EndIf 

   If iControlID == idFormatPlaylistHelp then 
   SayString (msgFormatPlaylistHelp)
   Return
   EndIf 

   If iControlID == idArtistAndTrack then 
   SayLine ()
   SayString (msgArtistAndTrack)
   Return
   EndIf 

   If iControlID == idArtistAndTrackChar then 
   SayString (msgArtistAmdTrackChar)
   SayString (GetSelectedText (False, False))
   Return
   EndIf 

   If iControlID == idFormatPlaylist then 
   SayString (msgFormatPlaylist)
   SayString (msgInfo)
   Return
   EndIf 

   If iControlID == idTracklistM3U then  
   SayString (msgTracklistM3U)
   Return
   EndIf 

   If iControlID == idTracklistPLS then  
   SayString (msgTracklistPLS)
   Return
   EndIf 
   
   If iControlID == idButtonChars then
   SayString (msgChars)
   Return
   EndIf 

EndIf ; If IsPage (cFilenames) then

; Dialog Zeichensatz

If GetWindowName (GetRealWindow(GetFocus())) == cReplace then
	If iControlID == idChar1 then
	SayString (msgChar1)
	ElIf iControlID == idChar2 then
	SayString (msgChar2)
	ElIf iControlID == idChar3 then
	SayString (msgChar3)
	ElIf iControlID == idChar4 then
	SayString (msgChar4)
	ElIf iControlID == idChar5 then
	SayString (msgChar5)
	ElIf iControlID == idChar6 then
	SayString (msgChar6)
	ElIf iControlID == idChar7 then
	SayString (msgChar7)
	ElIf iControlID == idChar8 then
	SayString (msgChar8)
	ElIf iControlID == idChar9 then
	SayString (msgChar9)
	ElIf iControlID == idChar10 then
    SayString (msgChar10)
    Endif
 SayString (GetSelectedText (False, False))
 Return
EndIf 

; CD-Laufwerk

If IsPage (cCDDrive) then

   If iControlID == idCDDrive then 
   SayString (msgCDDrive)
   SayString (FormatString("ausgewhlt ist %1", GetLine()))
   Return
   EndIf 

   If iControlID == idReadSectors then 
   SayString (msgReadSectors)
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf 


   If iControlID == idRepeat  then 
   SayString (msgRepeat)
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf 

   If iControlID == idSampleOffset then 
   SayString (msgSampleOffset)
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf 

   If iControlID == idStartOffset then
   SayString (msgStartOffset) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf 
   
   If iControlID == idSpeed then
   SayString (msgSpeed) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf 
   
   If iControlID == idEndOffset then
   SayString (msgEndOffset) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf 
   
   If iControlID == idSpinUpTime then
   SayString (msgSpinUpTime) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf    
   
   If iControlID == idDriveType then
   SayString (msgDriveType) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf 
   
   If iControlID == idExtractMethod then
   SayString (msgExtractMethod) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf   

EndIf ; If IsPage (cCDDrive) then

; Kodierer

If IsPage (cEncoder) then

   If iControlID == idPriority then
   SayString (msgPriority) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf   

   If iControlID == idEncoder then
   SayString (msgEncoder) 
   SayString (FormatString("%1", GetLine()))
   Return
   EndIf   

   If iControlID == idMinBitRate then
   SayString (msgMinBitRate) 
   SayString (FormatString("%1", GetWord ()))
   Return
   EndIf   
   
   If iControlID == idMaxBitRate then
   SayString (msgMaxBitRate) 
   SayString (FormatString("%1", GetWord ()))
   Return
   EndIf   
   
   If iControlID == idQuality then
   SayString (msgQuality) 
   SayString (FormatString("%1", GetWord()))
   Return
   EndIf  

   If iControlID == idVBRQuality then
   SayString (msgVBRQuality) 
   SayString (FormatString("%1", GetWord()))
   Return
   EndIf   
   
   If iControlID == idSampleRate then
   SayString (msgSampleRate) 
   SayString (FormatString("%1", GetWord()))
   Return
   EndIf   

EndIf ; If IsPage (cEncoder) then

; Lokale CDDB

If IsPage (cCDDBLocal) then

   If iControlID == idLocalCDDBPath then
   SayString (msgLocalCDDBPath) 
   SayString (msgF2ToChange)
   SayString (msgSayLine)
   ; SayLine ()
   Return
   EndIf   

   If iControlID == idWinamp then
   SayString (msgWinamp) 
   SayString (msgF2ToChange)
   SayString (msgSayLine)
   ; SayLine ()
   Return
   EndIf   

EndIf ; If IsPage (cCDDBLocal) then

; Remote CDDB

If IsPage (cCDDBRemote) then

   If iControlID == idRemoteServer then
   SayString (msgRemoteServer) 
   SayLine ()
   Return
   EndIf   

   If iControlID == idRemoteServerLocation then
   SayString (msgRemoteServerLocation) 
   SayLine ()
   Return
   EndIf   
 
   If iControlID == idRemoteServerAdress then
   SayString (msgRemoteServerAdress) 
   SayLine ()
   Return
   EndIf   
     
   If iControlID == idRemoteServerPath then
   SayString (msgRemoteServerPath) 
   SayLine ()
   Return
   EndIf   

   If iControlID == idRemoteServerProtocol then
   SayString (msgRemoteServerProtocol) 
   SayLine ()
   Return
   EndIf   
   
   If iControlID == idRemoteServerPort then
   SayString (msgRemoteServerPort) 
   SayLine ()
   Return
   EndIf   
   
   If iControlID == idMailAdress then
   SayString (msgMailAdress) 
   SayLine ()
   Return
   EndIf   

   If iControlID == idTimeout then
   SayString (msgTimeout) 
   SayLine ()
   Return
   EndIf   
  
   If iControlID == idUseProxy then
   SayString (msgUseProxy) 
   SayLine ()
   Return
   EndIf   

   If iControlID == idUseProxyPort then
   SayString (msgUseProxyPort) 
   SayLine ()
   Return
   EndIf   

   If iControlID == idAuthenticate then
   SayString (msgAuthenticate) 
   SayLine ()
   Return
   EndIf   
   
   If iControlID == idAuthenticatePW then
   SayString (msgAuthenticatePW) 
   SayLine ()
   Return
   EndIf   
   
EndIf ; If IsPage (cCDDBRemote) then

; Encoding

If IsPage (cEncoding) then


EndIf ; If IsPage (cEncoding) then

; TAGs

If IsPage (cTags) then

   If iControlID == idTrackNumberFormat then
   SayString (msgTrackNumberFormat) 
   SayLine ()
   Return
   EndIf   

   If iControlID == idComment then
   SayString (msgComment) 
   SayLine ()
   Return
   EndIf        
   
   If iControlID == idEncodedBy then
   SayString (msgEncodedBy) 
   SayLine ()
   Return
   EndIf    
   
   If iControlID == idPicturePath then
   SayString (msgPicturePath) 
   SayString (msgF2ToChange)
   SayString (MsgSayLine)
   Return
   EndIf    
   
   If iControlID == idPictureText then
   SayString (msgPictureText) 
   SayLine ()
   Return
   EndIf    

   If iControlID == idAddPicture then
   SayString (msgAddPicture) 
   SayLine ()
   Return
   EndIf        

EndIf ; If IsPage (cTags) then

FocusChangedEventEx (hwndFocus, nObject, nChild, hwndPrevFocus, nPrevObject, nPrevChild, nChangeDepth)
EndFunction

; ---------------------------------------------------------------------------------------------

int Function ChangeFolder (int iButton)
var
 object oUIA,
 object oElement,
 object oCondition

oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
if !oUIA then Return False EndIf 
oElement = oUIA.GetElementFromHandle(GetAppMainWindow(GetFocus()))
if !oElement then Return False EndIf 
oCondition = oUIA.CreateStringPropertyCondition(UIA_NamePropertyId, "...")
if !oCondition then Return False EndIf 

If iButton == btnTemp then
oElement = oElement.FindFirst (treeScope_descendants, oCondition)
else
oElement = oElement.FindAll (treeScope_descendants, oCondition)
EndIf 

If oElement && (iButton == btnTemp) then
oElement.GetInvokePattern().Invoke()
Return True
EndIf 

If oElement && (iButton == btnWaveToMp3) then
oElement(1).GetInvokePattern().Invoke()
Return True
EndIf 

if oElement && (iButton == btnRecord) then
oElement(0).GetInvokePattern().Invoke()
Return True
EndIf 

if oElement && (iButton == btnLocalCDDB) then
oElement(0).GetInvokePattern().Invoke()
Return True
EndIf 

if oElement && (iButton == btnWinamp) then
oElement(1).GetInvokePattern().Invoke()
Return True
EndIf 

if oElement && (iButton == btnPicture) then
oElement(0).GetInvokePattern().Invoke()
Return True
EndIf 

Return False
EndFunction 

; ---------------------------------------------------------------------------------------------

string Function GetTVText ()
If !IsSettingsDialog () then Return "" EndIf 
var 
handle hTreeView = FindWindow (GetRealWindow(GetFocus()), "SysTreeView32", "")
If hTreeView then 
Return tvGetFocusItemText (hTreeView)
else
Return ""
EndIf 
EndFunction

; ---------------------------------------------------------------------------------------------

void Function ReadExtractDialog (optional int iValue)
var
 object oUIA,
 object oElements,
 object oCondition, 
 object oFound, 
 object oEntry, 
 string sTemp
 
oUIA = CreateObjectEx ("FreedomSci.UIA", 0, "UIAScriptAPI.x.manifest" )
if !oUIA then Return EndIf 
oElements = oUIA.GetElementFromHandle(GetRealWindow(GetFocus()))
if !oElements then Return EndIf 
oCondition = oUIA.CreateIntPropertyCondition(UIA_ControlTypePropertyId, UIA_TextControlTypeId)
if !oCondition then Return EndIf 
oFound = oElements.FindAll (treeScope_descendants, oCondition)

if !iValue then
ForEach oEntry in oFound 
; If oElements then
; SayInteger (oFound.Count)
SayString (oEntry.Name)
EndForEach 
ElIf iValue == cTrackFromTrack then
sTemp = oFound(0).Name
sTemp = StringReplaceSubstrings (sTemp, "/", " von ")
SayString (sTemp)
ElIf iValue == cFilename then
sTemp = oFound(1).Name
sTemp = StringReplaceSubstrings (sTemp, "/", " von ")
SayString (sTemp)
ElIf iValue == cPeak then
sTemp = oFound(2).Name
sTemp = StringReplaceSubstrings (sTemp, "/", " von ")
SayString (sTemp)
ElIf iValue == cTimeTrack then
sTemp = oFound(3).Name
SayString (sTemp)
ElIf iValue == cTimeCD then
sTemp = oFound(4).Name
SayString (sTemp)
ElIf iValue == cJitter then
sTemp = oFound(5).Name
SayString (sTemp)
EndIf ; If !iValue then
EndFunction 

; ---------------------------------------------------------------------------------------------

Int Function IsExtractDialog ()
var
string sTitle = GetWindowName (GetRealWindow(GetFocus()))
If sTitle == cCDExExtractTracksTitle then
Return True
else 
Return False
EndIf 
EndFunction  

; ---------------------------------------------------------------------------------------------

Int Function IsConvertDialog ()
var
string sTitle = GetWindowName (GetRealWindow(GetFocus()))
If sTitle == cConvertDialogTitle then
Return True
else 
Return False
EndIf 
EndFunction  


; ---------------------------------------------------------------------------------------------

void Function HandleCustomRealWindows (handle hWindow)
var
string sTitle = GetWindowName (hWindow)
if sTitle == cOverwriteWindow then
; Sprache stoppen, damit nicht der ganze Umwandlungsdialog gesprochen wird 
StopSpeech ()
Endif 
EndFunction 

; ---------------------------------------------------------------------------------------------
; Skripts
; ---------------------------------------------------------------------------------------------

Script F2 ()
var
int iControlID = GetControlID (GetFocus())

If !IsSettingsDialog () then
; SayString (cNoSettingsDialog)
TypeCurrentScriptKey ()
Return
EndIf 

If iControlID == idTempFiles && IsPage (cCommon) then 
	If !ChangeFolder (btnTemp) then
	SayString (msgNoButtonFound)
	endIf 
EndIf 

If iControlID == idLocalCDDBPath && IsPage (cCDDBLocal) then 
	If !ChangeFolder (btnLocalCDDB) then
	SayString (msgNoButtonFound)
	endIf 
EndIf 

If iControlID == idWinamp && IsPage (cCDDBLocal) then 
	If !ChangeFolder (btnWinamp) then
	SayString (msgNoButtonFound)
	endIf 
EndIf 

If iControlID == idWaveToMp3 then 
	If !ChangeFolder (btnWaveToMp3) then
	SayString (msgNoButtonFound)
	endIf 
EndIf 

If iControlID == idRecord then 
	If !ChangeFolder (btnRecord) then
    SayString (msgNoButtonFound)
	endIf 
EndIf 

If iControlID == idPicturePath then 
	If !ChangeFolder (btnPicture) then
	SayString (msgNoButtonFound)
	endIf 
EndIf 

If iControlID == idFormat then
SayLine ()
SayString ("Dies entspricht")
SayString (GetNameFromAutomationID(cAutomationIDFormat))
EndIf 

If iControlID == idFormatPlaylist then
SayLine ()
SayString ("Dies entspricht")
SayString (GetNameFromAutomationID(cAutomationIDFormatPlaylist))
EndIf 

EndScript

; ---------------------------------------------------------------------------------------------

Script F6 ()
var
int iControlID = GetControlID (GetFocus()), 
handle hEditArtist = FindWindowWithClassAndId (GetAppMainWindow (GetFocus ()), cEdit, idArtist)

If IsSettingsDialog () then
ActivateByAutomationID (cAutomationIDTreeView)
Elif IsMainWindow () then
	If iControlID == idChangeDrive && hEditArtist then
	SetFocus (hEditArtist)
	EndIf 
EndIf 
EndScript

; ---------------------------------------------------------------------------------------------

Script FocusTreeView ()
var
handle hTree = FindWindowWithClassAndId (GetRealWindow(GetFocus()), "SysTreeView32", 32494)
If hTree then
SetFocus (hTree)
Pause ()
IypeKey ("UpArrow")
EndIf 
EndScript

; ---------------------------------------------------------------------------------------------

Script ScriptFileName()
ScriptAndAppNames(msgCDEx)
EndScript

; ---------------------------------------------------------------------------------------------

Script SayPage ()
var
handle hTree = FindWindowWithClassAndId (GetRealWindow(GetFocus()), "SysTreeView32", 32494)
If hTree then
SayString (FormatString("Kategorie %1", tvGetFocusItemText (hTree)))
EndIf 
EndScript

; ---------------------------------------------------------------------------------------------

Script SayTrackFromTrack ()
if IsExtractDialog () then
ReadExtractDialog (cTrackFromTrack)
EndIf 
EndScript 

; ---------------------------------------------------------------------------------------------

Script SayFilename ()
if IsExtractDialog () then
ReadExtractDialog (cFilename)
EndIf 
EndScript 

; ---------------------------------------------------------------------------------------------

Script SayPeak ()
if IsExtractDialog () then
ReadExtractDialog (cPeak)
EndIf 
EndScript 

; ---------------------------------------------------------------------------------------------

Script SayTimeTrack ()
if IsExtractDialog () then
ReadExtractDialog (cTimeTrack)
EndIf 
EndScript 

; ---------------------------------------------------------------------------------------------

Script SayTimeCD ()
if IsExtractDialog () then
ReadExtractDialog (cTimeCD)
EndIf 
EndScript 

; ---------------------------------------------------------------------------------------------

Script SayJitter ()
if IsExtractDialog () then
ReadExtractDialog (cJitter)
EndIf 
EndScript 

; ---------------------------------------------------------------------------------------------

Script SayProgress ()
if IsExtractDialog () then
ReadExtractDialog ()
EndIf 

If IsConvertDialog () then
ReadExtractDialog ()
EndIf 

EndScript

; ---------------------------------------------------------------------------------------------

Script Eject ()
if IsMainWindow () then
TypeKey ("Shift+F1")
EndIf 
EndScript

; ---------------------------------------------------------------------------------------------

Script ChangeDrive ()
var
handle hComboBox = FindWindowWithClassAndId (GetAppMainWindow(GetFocus()), cComboBox, idChangeDrive)
if IsMainWindow () && hComboBox then
SetFocus (hComboBox)
EndIf 
EndScript 

; ---------------------------------------------------------------------------------------------

Script TabScript ()
var
int iControlID = GetControlID (GetFocus()), 
handle hEditArtist = FindWindowWithClassAndId (GetAppMainWindow (GetFocus ()), cEdit, idArtist)
If IsMainWindow () && iControlID == idChangeDrive && hEditArtist then
	SetFocus (hEditArtist)
else
TypeCurrentScriptKey ()
EndIf 
EndScript 

